DROP VIEW ETL_CTRLPROPOSTAS
/

CREATE VIEW ETL_CTRLPROPOSTAS AS (
   SELECT NRPROPOSFAS, 
          NRVERPROPFAS,
          DSPROPOSTA, -- DIMENSAO: 05020 PROPOSTA
          IDTIPOPROPOSTA, -- DIMENSAO: 05018 TIPO DE PROPOSTA
          IDSITUACAOPROPOSTA,
          DSSITUACAOPROPOSTA, -- DIMENSAO: 05017 SITUACAO DA PROPOSTA
          IDCONTRATANTE, -- DIMENSAO: 05016 TIPO DE CONTRATANTE
          NMCONTRATANTE, -- DIMENSAO: 05015 CONTRATANTE
          CDCONTRATANTE, 
          NMSEGMERCADO, -- DIMENSAO: 05026 SEGMENTO DE MERCADO
          NMPAIS, -- DIMENSAO: 05013 PAS
          NMESTADO, -- DIMENSAO: 05012 ESTADO
          NMMUNICIPIO, -- DIMENSAO: 05014 MUNICPIO
          NMOPERADOR, -- DIMENSAO: 00305 OPERADOR
          CDAGENTENEGOCIO, -- DIMENSAO: 00322 AGENTE DE NEGOCIOS (OPERADOR)
          CDPROCOMERCI, -- DIMENSAO: 00040 PRODUTO COMERCIAL
          NMGERENTECOMERC, -- DIMENSAO: 05019 GERENTE COMERCIAL
          DSANOMESDIAPROPOSTA, -- DIMENSAO: 05023 PROPOSTA - DIA
          DSANOMESPROPOSTA, -- DIMENSAO: 05024 PROPOSTA - MES
          ANPROPOSTA, -- DIMENSAO: 05025 PROPOSTA - ANO
          DSANOMESDIAACEITE, -- DIMENSAO: 00436 ACEITE - DIA
          DSANOMESACEITE, -- DIMENSAO: 00435 ACEITE - MES
          ANACEITE, -- DIMENSAO: 00434 ACEITE - ANO
          DECODE(NRCONTADOR_PROPOSTA, 1, QTPROPOSTAACEITE, 0) AS QTPROPOSTAACEITE, -- FATO: QT. PROPOSTAS COM ACEITE
          DECODE(NRCONTADOR_PROPOSTA, 1, QTPROPOSTACONCLUIDA, 0) AS QTPROPOSTACONCLUIDA, -- FATO: QT. PROPOSTAS CONCLUDAS
          NMITEMPROPOSTA, -- DIMENSAO: 05021 ITEM DA PROPOSTA
          IDTIPOITEMPROPOSTA, -- DIMENSAO: 05022 TIPO DE ITEM DA PROPOSTA
          DSMODOLOCALPROC, -- DIMENSAO: 00441 MODO / LOCAL DE PROCESSAMENTO
          NRCONTADOR_SISTEMA,
          DSSISTEMA, -- DIMENSAO: 00303 SISTEMA
          DECODE(NRCONTADOR_SISTEMA, 1, QTSISTEMAS, 0) QTSISTEMAS,  -- FATO: QT. SISTEMAS
          DECODE(NRCONTADOR_SISTEMA, 1, QTMINIMALICENCAS, 0) QTMINIMALICENCAS, -- FATO: QT. MNIMA DE LICENAS
          QTMINIMALICENCAS * VRLICENCAUSO AS VRLICENCAUSO, -- FATO: VR.TOT.LIC.USO (C/DESCONTO)
          QTMINIMALICENCAS * VRDESCONTOLICENCAUSO AS VRDESCONTOLICENCAUSO, -- FATO: VR.TOT.DESCONTO LIC.USO
          QTMINIMALICENCAS * VRMENSALIDADE AS VRMENSALIDADE, -- FATO: VR.TOT.MENSAL (C/DESCONTO)
          QTMINIMALICENCAS * VRDESCONTOMENSALIDADE AS VRDESCONTOMENSALIDADE, -- FATO: VR.TOT.DESCONTO MENSALIDADE
          (QTMINIMALICENCAS * VRLICENCAUSO) + (QTMINIMALICENCAS * VRMENSALIDADE * 12) + (QTHRSERVICOESTIMADA * VRHRSERVICOAFATURAR) AS VRTOT_LU_MO_MENS12, -- FATO: LU+MO+MENSAL*12
          VRHRSERVICOCONTRATO, -- FATO: VR./HR.SERVIO000 (CONTRATO) 
          QTHRSERVICOESTIMADA, -- FATO: QT.HR.SERVIO (ESTIMADAS)
          VRHRSERVICOAFATURAR, -- FATO: VR./HR.SERVIO (C/DESCONTO)
          QTHRSERVICOESTIMADA * VRHRSERVICOAFATURAR AS VRTOTSERVICOAFATURAR -- FATO: VR.TOT.SERVIO (C/DESCONTO)
     FROM (SELECT PR.NRPROPOSFAS,
                  PR.NRVERPROPFAS,
                  PR.DSPROPOSTA,
                  PR.IDTIPOPROPOSTA,
                  PR.IDSITUACAOPROPOSTA,
                  PR.DSSITUACAOPROPOSTA,
                  PR.IDCONTRATANTE,
                  PR.NMCONTRATANTE,
                  PR.CDCONTRATANTE,
                  PR.NMSEGMERCADO,
                  PR.NMPAIS,
                  PR.NMESTADO,
                  PR.NMMUNICIPIO,
                  PR.NMOPERADOR,
                  PR.CDAGENTENEGOCIO,
                  PR.CDPROCOMERCI,
                  PR.NMGERENTECOMERC,
                  PR.DSANOMESDIAPROPOSTA,
                  PR.DSANOMESPROPOSTA,
                  PR.ANPROPOSTA,
                  PR.DSANOMESDIAACEITE,
                  PR.DSANOMESACEITE,
                  PR.ANACEITE,
                  PR.QTPROPOSTAACEITE,
                  PR.QTPROPOSTACONCLUIDA,
                  IP.NMITEMPROPOSTA,
                  IP.IDTIPOITEMPROPOSTA,
                  IP.DSMODOLOCALPROC,
                  SUM(1) OVER (PARTITION BY IP.NRPROPOSFAS, IP.NRVERPROPFAS
                                   ORDER BY IP.NRPROPOSFAS, IP.NRVERPROPFAS, IP.NMITEMPROPOSTA, IP.IDTIPOITEMPROPOSTA, IP.DSSISTEMA ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) NRCONTADOR_PROPOSTA,
                  SUM(1) OVER (PARTITION BY IP.NRPROPOSFAS, IP.NRVERPROPFAS, IP.NMITEMPROPOSTA
                                   ORDER BY IP.NRPROPOSFAS, IP.NRVERPROPFAS, IP.NMITEMPROPOSTA, IP.IDTIPOITEMPROPOSTA, IP.DSSISTEMA ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) NRCONTADOR_SISTEMA,
                  IP.DSSISTEMA, 
                  IP.QTSISTEMAS,
                  IP.QTMINIMALICENCAS, 
                  IP.VRLICENCAUSO,
                  IP.VRDESCONTOLICENCAUSO, 
                  IP.VRMENSALIDADE, 
                  IP.VRDESCONTOMENSALIDADE,
                  IP.VRHRSERVICOCONTRATO,
                  IP.QTHRSERVICOESTIMADA,
                  IP.VRHRSERVICOAFATURAR 
             FROM (SELECT PR.NRPROPOSFAS, 
                          PR.NRVERPROPFAS, 
                          LTRIM(PR.DSREFEPROPOSFAS||' '||PR.NRPROPOSFAS||'-'||PR.NRVERPROPFAS) AS DSPROPOSTA, 
                          CASE WHEN PR.IDTIPOPROPFAS = 'M' THEN 'LU/MANUTENO'
                               WHEN PR.IDTIPOPROPFAS = 'L' THEN 'LOCAO'
                               WHEN PR.IDTIPOPROPFAS = 'S' THEN 'SERVIO'
                          END AS IDTIPOPROPOSTA,
                          CASE WHEN PR.DTACEPROPFAS IS NOT NULL THEN 'AC' ELSE 'C'
                          END AS IDSITUACAOPROPOSTA,
                          CASE WHEN PR.DTACEPROPFAS IS NOT NULL THEN 'COM ACEITE / CONCLUDA'
                               ELSE 'CONCLUDA'
                          END AS DSSITUACAOPROPOSTA,
                          CASE WHEN PR.CDCLIENTE IS NOT NULL THEN 'CLIENTE'
                               ELSE 'PROSPECT'
                          END AS IDCONTRATANTE,
                          CASE WHEN PR.CDCLIENTE IS NOT NULL THEN CL.NMFANTCLIE||' ('||CL.NRINSJURCLIE||')'
                               ELSE PT.NMFANTPROS||' ('||PT.NRINSJURPROS||')'
                          END AS NMCONTRATANTE,
                          CASE WHEN PR.CDCLIENTE IS NOT NULL THEN CL.CDCLIENTE
                               ELSE PT.CDPROSPECT
                          END AS CDCONTRATANTE,
                          CASE WHEN PR.CDCLIENTE IS NOT NULL THEN NVL(SEC.DSSEGMER, 'NO CADASTRADO')
                               ELSE NVL(SEP.DSSEGMER, 'NO CADASTRADO')
                          END AS NMSEGMERCADO,
                          CASE WHEN PR.CDCLIENTE IS NOT NULL THEN PAC.NMPAIS
                               ELSE PAP.NMPAIS
                          END AS NMPAIS, 
                          CASE WHEN PR.CDCLIENTE IS NOT NULL THEN ESC.NMESTADO||' ('||EC.SGESTADO||')'
                               ELSE ESP.NMESTADO||' ('||EP.SGESTADO||')'
                          END AS NMESTADO, 
                          CASE WHEN PR.CDCLIENTE IS NOT NULL THEN MUC.NMMUNICIPIO
                               ELSE MUP.NMMUNICIPIO
                          END AS NMMUNICIPIO, 
                          OP.NMOPERADOR, 
                          PR.CDOPERSOLI CDAGENTENEGOCIO,
                          PR.CDPROCOMERCI,
                          CASE WHEN PR.CDCLIENTE IS NOT NULL THEN OGC.NMOPERADOR
                               ELSE NVL(OGE.NMOPERADOR, 'SEM GERENTE / EQUIPE' )
                          END AS NMGERENTECOMERC,
                          TO_CHAR(PR.DTPROPOSFAS, 'YYYY/MM/DD DY') DSANOMESDIAPROPOSTA,
                          TO_CHAR(PR.DTPROPOSFAS, 'YYYY/MM MONTH') DSANOMESPROPOSTA,
                          TO_CHAR(PR.DTPROPOSFAS,  'YYYY') ANPROPOSTA,
                          NVL(TO_CHAR(PR.DTACEPROPFAS, 'YYYY/MM/DD DY'), 'SEM ACEITE') DSANOMESDIAACEITE,
                          NVL(TO_CHAR(PR.DTACEPROPFAS, 'YYYY/MM MONTH'), 'SEM ACEITE') DSANOMESACEITE,
                          NVL(TO_CHAR(PR.DTACEPROPFAS, 'YYYY'), 'SEM') ANACEITE,
                          CASE WHEN PR.DTACEPROPFAS IS NOT NULL THEN 1
                               ELSE 0
                          END AS QTPROPOSTAACEITE, 
                          1 AS QTPROPOSTACONCLUIDA 
                     FROM EQUIPETRAB EQ, FUNCIONARIO FU, OPERADOR OP, OPERADOR OGE, OPERADOR OS,
                          OPERADOR OGC, SEGMERCADO SEC, SEGMERCADO SEP, MUNICIPIO MUC, ESTADO ESC, PAIS PAC,
                          MUNICIPIO MUP, ESTADO ESP, PAIS PAP, ENDECLIE EC,
                          ENDEPROSPECT EP, CLIENTE CL, PROSPECT PT, PROPOSTAFAS PR
                    WHERE PR.IDSOLPROPFAS = 'N' -- CONCLUDA INDEPENDENTE DE ACEITE
                      AND CL.CDCLIENTE (+) = PR.CDCLIENTE
                      AND PT.CDPROSPECT (+) = PR.CDPROSPECT
                      AND EC.CDCLIENTE (+) = PR.CDCLIENTE
                      AND EC.IDTPENDECLIE (+) = 'P'
                      AND EP.CDPROSPECT (+) = PR.CDPROSPECT
                      AND EP.IDTPENDEPROS (+) = 'P'
                      AND PAC.CDPAIS (+) = EC.CDPAIS
                      AND ESC.CDPAIS (+) = EC.CDPAIS
                      AND ESC.SGESTADO (+) = EC.SGESTADO
                      AND MUC.CDPAIS (+) = EC.CDPAIS
                      AND MUC.SGESTADO (+) = EC.SGESTADO
                      AND MUC.CDMUNICIPIO (+) = EC.CDMUNICIPIO
                      AND SEC.CDSEGMER (+) = CL.CDSEGMER
                      AND PAP.CDPAIS (+) = EP.CDPAIS
                      AND ESP.CDPAIS (+) = EP.CDPAIS
                      AND ESP.SGESTADO (+) = EP.SGESTADO
                      AND MUP.CDPAIS (+) = EP.CDPAIS
                      AND MUP.SGESTADO (+) = EP.SGESTADO
                      AND MUP.CDMUNICIPIO (+) = EP.CDMUNICIPIO
                      AND SEP.CDSEGMER (+) = PT.CDSEGMER
                      AND OGC.CDOPERADOR (+) = CL.CDGERENTECOMERC
                      AND OS.CDOPERADOR = PR.CDOPERSOLI
                      AND FU.CDEMPRESA (+)= OS.CDEMPRESA
                      AND FU.CDFUNC (+)= OS.CDFUNC
                      AND EQ.CDEQUIPETRAB (+) = FU.CDEQUIPETRAB
                      AND OGE.CDOPERADOR (+) = EQ.CDOPERRESP
                      AND OP.CDOPERADOR (+) = PR.CDOPERINCL
                      AND (PR.DTACEPROPFAS IS NOT NULL -- PROPOSTA COM ACEITE
                          OR
                          (PR.NRPROPOSFAS||'-'||PR.NRVERPROPFAS = (SELECT MAX(PA.NRPROPOSFAS||'-'||PA.NRVERPROPFAS)
                                                                     FROM PROPOSTAFAS PA
                                                                    WHERE PA.NRPROPOSFAS = PR.NRPROPOSFAS)
                           AND NOT EXISTS (SELECT PA.NRPROPOSFAS
                                             FROM PROPOSTAFAS PA
                                            WHERE PA.NRPROPOSFAS = PR.NRPROPOSFAS
                                              AND PA.DTACEPROPFAS IS NOT NULL)))) PR,
                  (SELECT SE.NRPROPOSFAS,
                          SE.NRVERPROPFAS,
                          TS.NMTIPOSERV||' (cod. '||SE.CDTIPOSERV||')' AS NMITEMPROPOSTA, 
                          'SERVIO' AS IDTIPOITEMPROPOSTA, 
                          'SERVIO' DSMODOLOCALPROC, 
                          'SERVIO' DSSISTEMA, 
                          0 AS QTSISTEMAS,
                          0 AS QTMINIMALICENCAS,
                          0 VRLICENCAUSO,
                          0 VRDESCONTOLICENCAUSO,
                          0 VRMENSALIDADE,
                          0 VRDESCONTOMENSALIDADE,
                          VRHORAPROP AS VRHRSERVICOCONTRATO,
                          QTSERVPROP AS QTHRSERVICOESTIMADA,
                          VRDEHORAPROP AS VRHRSERVICOAFATURAR
                    FROM TIPOSERV TS, PROPOSTASERV SE
                    WHERE TS.CDTIPOSERV = SE.CDTIPOSERV
                      AND SE.QTSERVPROP < 999999.99
                    UNION ALL
                   SELECT LP.NRPROPOSFAS,
                          LP.NRVERPROPFAS,
                          LP.NMLINPPROP||' (cod. '||LP.CDLINPPROPINFOR||')' AS NMITEMPROPOSTA, 
                          'LINHA DE PRODUTO' AS IDTIPOITEMPROPOSTA, 
                          DECODE(LP.IDMPROCLINPP, 'M', 'MATRIZ', 'F', 'FILIAL')||' / '||DECODE(LP.IDLPROCLINPP, 'M', 'MATRIZ', 'F', 'FILIAL') DSMODOLOCALPROC, -- DIMENSAO 00441 MODO / LOCAL DE PROCESSAMENTO
                          SI.CDSISTEMA||' - '||SI.NMSISTEMA DSSISTEMA, 
                          QS.QTSISTEMAS,
                          LP.QTMINIMAFATPROP QTMINIMALICENCAS,
                          (LP.VRLICENCUSOPROP - LP.VRDESLICUSOPROP) / QS.QTSISTEMAS VRLICENCAUSO,
                          LP.VRDESLICUSOPROP / QS.QTSISTEMAS VRDESCONTOLICENCAUSO,
                          (LP.VRMENSALIDAPROP - LP.VRDESMENSALPROP) / QS.QTSISTEMAS VRMENSALIDADE,
                          LP.VRDESMENSALPROP / QS.QTSISTEMAS VRDESCONTOMENSALIDADE,
                          0 AS VRHRSERVICOCONTRATO,
                          0 AS QTHRSERVICOESTIMADA,
                          0 AS VRHRSERVICOAFATURAR
                     FROM (SELECT NRPROPOSFAS, NRVERPROPFAS, CDLINPPROP, COUNT(*) QTSISTEMAS
                             FROM SISTPROPLINP
                            GROUP BY NRPROPOSFAS, NRVERPROPFAS, CDLINPPROP) QS,
                          SISTEMA SI, SISTPROPLINP SP, PROPOSTALINP LP
                    WHERE QS.NRPROPOSFAS = LP.NRPROPOSFAS
                      AND QS.NRVERPROPFAS = LP.NRVERPROPFAS
                      AND QS.CDLINPPROP = LP.CDLINPPROP
                      AND SP.NRPROPOSFAS = LP.NRPROPOSFAS
                      AND SP.NRVERPROPFAS = LP.NRVERPROPFAS
                      AND SP.CDLINPPROP = LP.CDLINPPROP
                      AND SI.CDSISTEMA = SP.CDSISTEMA) IP
            WHERE IP.NRPROPOSFAS = PR.NRPROPOSFAS
              AND IP.NRVERPROPFAS = PR.NRVERPROPFAS
              AND PR.CDCONTRATANTE NOT IN ('J26269316000177', 'I00000000000132153215', 'J06240810000100', 'J06348006000130', 'F03924269602', 'J05118011000194', 'I00000000000000067084'))
)
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_CTRLPROPOSTAS','0.00.000'); END;
/
